



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>WebGL模型拾取——射线法</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">WebGL模型拾取——射线法</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-25 04:44:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>　　今天要把WebGL中一个非常重要的算法记录下来&mdash;&mdash;raycaster射线法拾取模型。首先我们来了解一下为什么要做模型拾取，我们在做webgl场景交互的时候经常要选中场景中的某个模型，比如鼠标拖拽旋转，平移。为了能做到鼠标交互，就首先要能选中场景中的模型对象，这就要用到模型拾取算法，本文仅讨论射线法模型拾取raycaster。</p>
<p>　　所谓射线法就是利用一根射线去和场景中的模型进行碰撞，撞到的模型对象就是被拾取到的模型。请看下图</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1445864/201811/1445864-20181117094512209-1075073863.png" /></p>
<p>　　我逐个来解释一下上图中的元素。首先解释相机（camera），这就是人眼的抽象，代表用户在屏幕前的眼睛位置。人眼看到的世界是透视的（perspective），因此我们构造的视棱台（frustum）基于透视投影。整个视棱台区域介于场景近截面（near）和远截面（far）之间，这个区间内的空间就是我们可以看到的场景空间。需要说明一下，near近截面我们这里紧贴屏幕（screen），即距离很小约等于0.1，far远截面就是我们认为的视线最远能看到的距离，我们这里设置为1000。屏幕screen在近截面前0.1的位置上，也是离人眼最近的截面，也是鼠标交互的界面，这是要事先解释明白的。理解了这个空间结构以后我们就开始讲解raycaster的算法原理。</p>
<p>　　首先我们来看一下鼠标在屏幕上的位置点P0，我们可以看到P0点（鼠标），这个就是鼠标在屏幕上的位置。我们再来看看triangle1三角形1，这就是透视空间中triangle2三角形2在屏幕上的投影。我们可以明显看到鼠标位置P0点在屏幕triangle1三角形1内部，即鼠标点选中triangle1三角形1。这在屏幕上可以看的很清楚，但是问题来了，在空间中鼠标是没有深度概念的，即鼠标只有XY坐标，没有Z坐标，那我们在视棱台的空间坐标系中如何表示鼠标的三维空间位置呢，如果没有鼠标的3维空间坐标，如何判断在视棱台空间中鼠标是否选中triangle2三角形2这个模型对象呢？也许有同学会说，triangle1就是triangle2的投影嘛，选中投影就是选中模型了不是，我就这么说，非常正确，能说出这样的话就已经完全理解了模型在屏幕上的投影的原理，但是新的问题随之又来了，如何获取鼠标点选模型的坐标呢，即如何得到鼠标点在模型上的那个点的三维空间坐标呢，如果仅仅判断是否选中，那投影就够用了，但要计算鼠标点选模型上的点坐标，就远远不够用了。为了解决这个问题，raycaster算法应运而生。</p>
<p>　　raycaster顾名思义就是射线投射。他的原理其实非常简单，就是用一根射线去交有限平面，获得交点。射线是有起点的，起点就是我们的眼睛。我们做一根起于camera，通过鼠标在屏幕上的位置P0，继续延伸，交视棱台近截面于P1，继续延伸，交视棱台远截面于P3，射线截止，我们得到了一根线段P1-P3。这根线段P1-P3就是我们眼睛能看到的鼠标发出的射线在透视空间中的部分，凡是这根线段碰到的模型，都是鼠标点选中的空间模型。而这根线段和模型的交点就是鼠标点选模型的交点，这个交点坐标就是鼠标点选模型的交点空间三维坐标。这样就顺利解决了上面我们的问题，即求鼠标点选空间三维模型的交点坐标。在上图中我们看得很清楚，这个交点就是P2，接下来我们就来讲解怎么求这个P2的空间坐标。</p>
<p>　　做图形学的同学们都非常清楚。如何求线段和平面的交点，这里我截取一部分代码，以供叙述方便，以下就是求线段截取平面交点的函数。</p>
<div>
<pre class="prettyprint linenums">/*

 */<br />
let Intersector = require('./Intersector');<br />
let LineSegmentIntersection = require('./Intersection').LineSegmentIntersection;<br />
let Vec3 = require('./Vec3');<br />
let Mat4 = require('./Mat4');<br />
let Algorithm = require('./Algorithm');

let LineSegmentIntersector = function () {<br />
    Intersector.call(this);

    //原始的起始点和临界值，初始化设置的数据，保留作为参照，设置后不再变动<br />
    this._orginStart = Vec3.new();//线段起点<br />
    this._orginEnd = Vec3.new();//线段终点<br />
    this._orginThreshold = 0.0;//点和线求相交时的临界值，完全相交是很难求到的

    //临时存储，每次求交都可能会变动的数据<br />
    //对于有变换的几何求交，不会变换几何顶点而是变换起始点和临界值<br />
    this._start = Vec3.new();//线段起点<br />
    this._end = Vec3.new();//线段终点<br />
    this._threshold = 0.0;//点和线求相交时的临界值，完全相交是很难求到的

    this._direction = Vec3.new();<br />
    this._length = ;<br />
    this._inverseLength = ;<br />
    this._matrix = Mat4.new();<br />
};

LineSegmentIntersector.prototype = Object.create(Intersector.prototype);<br />
LineSegmentIntersector.prototype.constructor = LineSegmentIntersector;<br />
Object.assign(LineSegmentIntersector.prototype, {<br />
    init: function (start, end, threshold) {<br />
        Vec3.copy(this._orginStart, start);<br />
        Vec3.copy(this._orginEnd, end);<br />
        Vec3.copy(this._start, start);<br />
        Vec3.copy(this._end, end);

        if (threshold !== undefined) {<br />
            this._orginThreshold = threshold;<br />
            this._threshold = threshold;<br />
        }<br />
    },<br />
    intersect: function (drawable) {<br />
        //先使用包围盒子<br />
        if (!drawable.getBoundingBox().intersectLineSegment(this._orginStart, this._orginEnd)) {<br />
            return;<br />
        }

        this._drawable = drawable;<br />
        let geometry = drawable.getGeometry();<br />
        let vertexbuffer = geometry.getBufferArray('Vertex');<br />
        this._vertices = vertexbuffer.getArrayBuffer();<br />
        //没有顶点数据不处理直接返回<br />
        if (!this._vertices) return;

        //没有图元不处理直接返回<br />
        let primitive = geometry.getPrimitive();<br />
        if (!primitive) return;

        //初始化求相交的各种数据<br />
        let matrix = drawable.getTransform();<br />
        if (this._transform !== matrix) {//如果不一样，需要计算新的起始点以及各种临时数据<br />
            this._transform = matrix;<br />
            Mat4.invert(this._matrix, matrix);

            //根据矩阵计算新的临界值<br />
            if (this._orginThreshold &gt; 0.0) {<br />
                let tmp = this._start;<br />
                Mat4.getScale(tmp, this._matrix);<br />
                let x = tmp[];<br />
                let y = tmp[];<br />
                let z = tmp[];<br />
                this._threshold = this._orginThreshold * (x &gt; y ? (x &gt; z ? x : z) : y &gt; z ? y : z);<br />
            }<br />
            //根据矩阵计算新的起始点<br />
            Vec3.transformMat4(this._start, this._orginStart, this._matrix);<br />
            Vec3.transformMat4(this._end, this._orginEnd, this._matrix);

            //根据新的起始点计算各种临时数据<br />
            Vec3.sub(this._direction, this._end, this._start);<br />
            this._length = Vec3.length(this._direction);//长度<br />
            this._inverseLength = this._length &lt;= Algorithm.EPSILON ? 0.0 : 1.0 / this._length;<br />
            Vec3.scale(this._direction, this._direction, this._inverseLength);//求单位向量<br />
        }//如果变换与上次一样，直接使用上次的数据求相交

        //求相交<br />
        primitive.operate(this);<br />
    },<br />
    intersectPoint: function (vertex) {<br />
        // https://www.geometrictools.com/GTEngine/Include/Mathematics/GteDistPointSegment.h<br />
        //起点指向绘制点，向量M<br />
        let m = Vec3.MemoryPool.alloc();<br />
        Vec3.sub(m, vertex, this._start);<br />
        //起点指向终点，向量N<br />
        let n = Vec3.MemoryPool.alloc();<br />
        Vec3.sub(n, this._end, this._start);

        //求M在N上的投影比例值<br />
        //|m|*|n|*cos / \n\*\n\ = |m|*cos/\n\<br />
        let r = Vec3.dot(m, n) * this._inverseLength * this._inverseLength;

        //计算绘制点到线段的距离<br />
        let sqrdist = 1.0;<br />
        if (r &lt; 0.0) {//夹角超过90度，绘制点在当前线段起点后面，求绘制点与起点的距离<br />
            sqrdist = Vec3.sqrLen(m);<br />
        } else if (r &gt; 1.0) {//绘制点在当前线段终点后面，求绘制点与终点的距离<br />
            sqrdist = Vec3.sqrDist(vertex, this._end);<br />
        } else {//在0到1之间<br />
            //m - n * r 如果平行或者接近于平行，结果接近于0，相交<br />
            sqrdist = Vec3.sqrLen(Vec3.scaleAndAdd(m, m, n, -r));<br />
        }

        let intersection = undefined;<br />
        if (sqrdist &gt; this._threshold * this._threshold) {//超过了临界值，没有相交返回

        } else {<br />
            //相交<br />
            intersection = new LineSegmentIntersection();<br />
            //intersection._i1 = index;<br />
            //intersection._r1 = 1.0;<br />
            Vec3.scaleAndAdd(intersection._point, this._start, n, r);<br />
            intersection._ratio = r;<br />
        }<br />
        Vec3.MemoryPool.free(m);<br />
        Vec3.MemoryPool.free(n);<br />
        return intersection;<br />
    },<br />
    intersectLine: function (vertex0, vertex1) {<br />
        // https://www.geometrictools.com/GTEngine/Samples/Geometrics/DistanceSegments3/DistanceSegments3.cpp<br />
        //let epsilon = 0.00000001;

        //起点到终点的向量<br />
        let u = Vec3.MemoryPool.alloc();<br />
        Vec3.sub(u, vertex1, vertex0);<br />
        let v = Vec3.MemoryPool.alloc();<br />
        Vec3.sub(v, this._end, this._start);<br />
        let w = Vec3.MemoryPool.alloc();<br />
        Vec3.sub(w, vertex0, this._start);

        let a = Vec3.dot(u, u);<br />
        let b = Vec3.dot(u, v);<br />
        let c = Vec3.dot(v, v);<br />
        let d = Vec3.dot(u, w);<br />
        let e = Vec3.dot(v, w);<br />
        let D = a * c - b * b;<br />
        let sN;<br />
        let tN;<br />
        let sD = D;<br />
        let tD = D;

        // compute the line parameters of the two closest points<br />
        if (D &lt; Algorithm.EPSILON) {//平行<br />
            // the lines are almost parallel<br />
            sN = 0.0; // force using point P0 on segment S1<br />
            sD = 1.0; // to prevent possible division by 0.0 later<br />
            tN = e;<br />
            tD = c;<br />
        } else {<br />
            // get the closest points on the infinite lines<br />
            sN = b * e - c * d;<br />
            tN = a * e - b * d;<br />
            if (sN &lt; 0.0) {<br />
                // sc &lt; 0 =&gt; the s=0 edge is visible<br />
                sN = 0.0;<br />
                tN = e;<br />
                tD = c;<br />
            } else if (sN &gt; sD) {<br />
                // sc &gt; 1  =&gt; the s=1 edge is visible<br />
                sN = sD;<br />
                tN = e + b;<br />
                tD = c;<br />
            }<br />
        }

        if (tN &lt; 0.0) {<br />
            // tc &lt; 0 =&gt; the t=0 edge is visible<br />
            tN = 0.0;<br />
            // recompute sc for this edge<br />
            if (-d &lt; 0.0) sN = 0.0;<br />
            else if (-d &gt; a) sN = sD;<br />
            else {<br />
                sN = -d;<br />
                sD = a;<br />
            }<br />
        } else if (tN &gt; tD) {<br />
            // tc &gt; 1  =&gt; the t=1 edge is visible<br />
            tN = tD;<br />
            // recompute sc for this edge<br />
            if (-d + b &lt; 0.0) sN = ;<br />
            else if (-d + b &gt; a) sN = sD;<br />
            else {<br />
                sN = -d + b;<br />
                sD = a;<br />
            }<br />
        }<br />
        // finally do the division to get sc and tc<br />
        let sc = Math.abs(sN) &lt; Algorithm.EPSILON ? 0.0 : sN / sD;<br />
        let tc = Math.abs(tN) &lt; Algorithm.EPSILON ? 0.0 : tN / tD;

        // get the difference of the two closest points<br />
        let closest0 = Vec3.MemoryPool.alloc();<br />
        let closest1 = Vec3.MemoryPool.alloc();<br />
        Vec3.scaleAndAdd(closest0, vertex0, u, sc);<br />
        Vec3.scaleAndAdd(closest1, this._start, v, tc);

        let sqrDistance = Vec3.sqrDist(closest0, closest1);<br />
        Vec3.MemoryPool.free(closest0);<br />
        Vec3.MemoryPool.free(closest1);

        let intersection = undefined;<br />
        if (sqrDistance &gt; this._threshold * this._threshold) {

        } else {<br />
            //相交<br />
            intersection = new LineSegmentIntersection();<br />
            // intersection._i1 = index0;<br />
            // intersection._i2 = index1;<br />
            // intersection._r1 = 1.0 - tc;<br />
            // intersection._r2 = tc;<br />
            Vec3.copy(intersection._point, closest1);<br />
            intersection._ratio = tc;<br />
        }<br />
        Vec3.MemoryPool.free(u);<br />
        Vec3.MemoryPool.free(v);<br />
        Vec3.MemoryPool.free(w);<br />
        return intersection;<br />
    },<br />
    intersectTriangle: function (vertex0, vertex1, vertex2) {<br />
        let e2 = Vec3.MemoryPool.alloc();<br />
        Vec3.sub(e2, vertex2, vertex0);<br />
        let e1 = Vec3.MemoryPool.alloc();<br />
        Vec3.sub(e1, vertex1, vertex0);<br />
        let pvec = Vec3.MemoryPool.alloc();<br />
        Vec3.cross(pvec, this._direction, e2);

        let intersection = undefined;<br />
        //线段与三角面点积<br />
        let det = Vec3.dot(pvec, e1);<br />
        //判断三角形所在的平面与线段是否平行，如果平行铁定不相交，面片没有厚度<br />
        if (Math.abs(det) &lt; Algorithm.EPSILON) {<br />
            //return undefined;<br />
        }else{<br />
            let invDet = 1.0 / det;<br />
            let tvec = Vec3.MemoryPool.alloc();<br />
            Vec3.sub(tvec, this._start, vertex0);<br />
            let u = Vec3.dot(pvec, tvec) * invDet;<br />
            //三角面超出了线段两个点范围外面，铁定不相交<br />
            if (u &lt; 0.0 || u &gt; 1.0) {<br />
                //return undefined;<br />
            }else{<br />
                let qvec = Vec3.MemoryPool.alloc();<br />
                Vec3.cross(qvec, tvec, e1);<br />
                let v = Vec3.dot(qvec, this._direction) * invDet;<br />
                //<br />
                if (v &lt; 0.0 || u + v &gt; 1.0) {<br />
                    //return undefined;<br />
                }else{<br />
                    let t = Vec3.dot(qvec, e2) * invDet;<br />
                    if (t &lt; Algorithm.EPSILON || t &gt; this._length) {<br />
                        //return undefined;<br />
                    }else{<br />
                        //相交<br />
                        intersection = new LineSegmentIntersection();

                        //求相交点<br />
                        let r0 = 1.0 - u - v;<br />
                        let r1 = u;<br />
                        let r2 = v;<br />
                        let r = t * this._inverseLength;<br />
                        let interX = vertex0[] * r0 + vertex1[] * r1 + vertex2[] * r2;<br />
                        let interY = vertex0[] * r0 + vertex1[] * r1 + vertex2[] * r2;<br />
                        let interZ = vertex0[] * r0 + vertex1[] * r1 + vertex2[] * r2;<br />
                        // intersection._i1 = index0;<br />
                        // intersection._i2 = index1;<br />
                        // intersection._i3 = index2;<br />
                        // intersection._r1 = r0;<br />
                        // intersection._r2 = r1;<br />
                        // intersection._r3 = r2;

                        //这里的点没有经过变换，不是真实的世界坐标点<br />
                        Vec3.set(intersection._point, interX, interY, interZ);<br />
                        Vec3.transformMat4(intersection._point, intersection._point, this._transform);

                        //求法向量，法向量未变换，如果有用途也要变换<br />
                        let normal = intersection._normal;<br />
                        Vec3.cross(normal, e1, e2);<br />
                        Vec3.normalize(normal, normal);<br />
                        //比例，在相交线段上的比例，不需要变换<br />
                        intersection._ratio = r;<br />
                     }<br />
                }<br />
                Vec3.MemoryPool.free(qvec);<br />
            }<br />
            Vec3.MemoryPool.free(tvec);<br />
        }<br />
        Vec3.MemoryPool.free(e1);<br />
        Vec3.MemoryPool.free(e2);<br />
        Vec3.MemoryPool.free(pvec);<br />
        return intersection;<br />
        // http://gamedev.stackexchange.com/questions/54505/negative-scale-in-matrix-4x4<br />
        // https://en.wikipedia.org/wiki/Determinant#Orientation_of_a_basis<br />
        // you can't exactly extract scale of a matrix but the determinant will tell you<br />
        // if the orientation is preserved<br />
        //intersection._backface = mat4.determinant(intersection._matrix) * det &lt; 0;<br />
    },<br />
    intersectBoundingBox: function (box) {<br />
        return box.intersectLineSegment(this._orginStart, this._orginEnd);<br />
    },<br />
});

module.exports = LineSegmentIntersector;

// setDrawable: function (drawable) {<br />
//     this._geometry = drawable.getGeometry();<br />
//     this._vertices = this._geometry.getBufferArray('Vertex');<br />
//<br />
//     let matrix = drawable.getTransform();<br />
//     if (this._transform === matrix) {//如果与上次的一样，不再处理<br />
//         return;<br />
//     }<br />
//<br />
//     //如果不一样，需要计算新的起始点已经各种临时数据<br />
//     this._transform = matrix;<br />
//     Mat4.invert(this._matrix, matrix);<br />
//<br />
//     //根据矩阵计算新的临界值<br />
//     if (this._orginThreshold &gt; 0.0) {<br />
//         let tmp = this._start;<br />
//         Mat4.getScale(tmp, this._matrix);<br />
//         let x = tmp[0];<br />
//         let y = tmp[1];<br />
//         let z = tmp[2];<br />
//         this._threshold = this._orginThreshold * (x &gt; y ? (x &gt; z ? x : z) : y &gt; z ? y : z);<br />
//     }<br />
//     //根据矩阵计算新的起始点<br />
//     Vec3.transformMat4(this._start, this._orginStart, this._matrix);<br />
//     Vec3.transformMat4(this._end, this._orginEnd, this._matrix);<br />
//<br />
//     //根据新的起始点计算各种临时数据<br />
//     Vec3.sub(this._direction, this._end, this._start);<br />
//     this._length = Vec3.length(this._direction);//长度<br />
//     this._inverseLength = this._length &lt;= Algorithm.EPSILON ? 1.0 / this._length : 0.0;<br />
//     Vec3.scale(this._direction, this._direction, this._inverseLength);//求单位向量<br />
// },<br />
// setGeometry: function (geometry, matrix) {<br />
//     Intersector.prototype.setGeometry.call(this, geometry, matrix);<br />
//<br />
//     //如果不一样，需要计算新的起始点已经各种临时数据<br />
//     Mat4.invert(this._matrix, matrix);<br />
//<br />
//     //根据矩阵计算新的临界值<br />
//     if (this._orginThreshold &gt; 0.0) {<br />
//         let tmp = this._start;<br />
//         Mat4.getScale(tmp, this._matrix);<br />
//         let x = tmp[0];<br />
//         let y = tmp[1];<br />
//         let z = tmp[2];<br />
//         this._threshold = this._orginThreshold * (x &gt; y ? (x &gt; z ? x : z) : y &gt; z ? y : z);<br />
//     }<br />
//     //根据矩阵计算新的起始点<br />
//     Vec3.transformMat4(this._start, this._orginStart, this._matrix);<br />
//     Vec3.transformMat4(this._end, this._orginEnd, this._matrix);<br />
//<br />
//     //根据新的起始点计算各种临时数据<br />
//     Vec3.sub(this._direction, this._end, this._start);<br />
//     this._length = Vec3.length(this._direction);//长度<br />
//     this._inverseLength = this._length &lt;= Algorithm.EPSILON ? 1.0 / this._length : 0.0;<br />
//     Vec3.scale(this._direction, this._direction, this._inverseLength);//求单位向量<br />
// },<br />
// setGeometry: function (geometry) {<br />
//     //没有顶点数据不处理直接返回<br />
//     let vertexbuffer = geometry.getBufferArray('Vertex');<br />
//     if(!vertexbuffer) return;<br />
//<br />
//     //没有图元不处理直接返回<br />
//     let primitive = geometry.getPrimitive();<br />
//     if (primitive)<br />
//         primitive.operate(this);<br />
// },</pre>
</div>
<p>　　以上的LineSegmentIntersector就是计算线段和平面交点的类，具体算法不再赘述，请自行参考《WebGL编程指南》。好了，我们接下来就看一个项目中的具体案例，请看下图</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1445864/201811/1445864-20181117104515585-1378145721.png" /></p>
<p>　　我们在pick事件中使用了LineSegmentIntersector对场景中的包围盒和坐标系模型进行了raycaster射线碰撞检测，结果我们得到了一系列的返回对象，其中包括包围盒的2个面，坐标系的一根坐标轴的geometry，这就另我们觉得难办了，鼠标射线碰到了不止一个模型，我们该怎么办呢，这里就要说明一下，一般我们都取离near近截面最近的一个模型作为我们pick选中的模型，因为其他模型都被处于前方的该模型遮挡住了。</p>
<p>　　好了，今天对raycaster的解释就结束了，只是初步了解一下，raycaster还有很多应用场景，这里和我们的鼠标拾取不相关的就不介绍了，谢谢大家阅读，欢迎大家一起留言探讨，再次感谢。转载本文请注明出处：https://www.cnblogs.com/ccentry/p/9973165.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m8zzlon8.html">POJ 1236-Network of Schools &lpar;图论-有向图强联通tarjan）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlz2d68.html">Spark Programming--WordCount</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd6llxq.html">【基于spark IM 的二次开发笔记】第一天 各种配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1k5o38.html">【实习记】2014-09-01从复杂到简单：一行命令区间查重&plus;长整型在awk中的bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn4dm2q.html">yarn的初步理解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1z41j9.html">windows和linux双系统删除linux</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdjdo48.html">tomcat path配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vwxw48.html">iOS工程上传AppStore时遇到的问题&OpenCurlyDoubleQuote;ERROR ITMS-90046&rdquo;解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjd17x8.html">ural 1073&period;Square Country（动态规划）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkjyvz8.html">一个轻量级iOS安全框架：SSKeyChain</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me4dm2q.html">转载：使用Math&period;floor和Math&period;random取随机整数</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gdd2mq.html">iptables 分析&lpar;1&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1x2og9.html">Matlab adaptive quadrature</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j13mjq.html">确界原理  supremum and infimum principle  戴德金定理  Dedekind theorem</a>
		</li>
						<li><a href="https://www.batexi.com/a/960rod49.html">Sublime Text3 插件：DocBlockr与javascript注释规范</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllg440q.html">golang基础学习</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4pzeyeq.html">Jenkins知识地图</a>
		</li>
						<li><a href="https://www.batexi.com/a/8komgy5q.html">octomap的简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxlkxk0q.html">学习python4</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxlevn0q.html">CentOS7&period;1 安装Liberty之环境准备（1）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q4jexe0q.html">转：winform 打包自动安装数据库</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5jjrdq.html">AndroidManifest 配置主活动</a>
			</li>
						<li><a href="https://www.batexi.com/a/8emeypm9.html">&lbrack;工具&rsqb;iperf测试带宽</a>
			</li>
						<li><a href="https://www.batexi.com/a/qve52ex9.html">java多重转型问题</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ppnw749.html">BZOJ 1934 善意的投票</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ko0j45q.html">python第三十一课－－递归&lpar;2&period;遍历某个路径下面的所有内容&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zkgy2x8.html">Tushare test</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pg4x3q.html">apache&comma;R&comma;P&comma;url重写，伪静态，反向代理</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4pgm5jq.html">ocv &amp;amp&semi; derate &amp;amp&semi; crpr</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjmpw68.html">scrollIntoView&lpar;&rpar;的用法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
